/*-
 * Copyright (C) @BABOLO  2007 Nov 20
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C) @BABOLO  2007 Nov 20\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: descript.c,v 1.7 2007/12/11 10:15:59 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <stdio.h>
#include <mife.h>
#include <multilar.h>
#include <libpq-fe.h>
#include "pgoblin.h"
#include "pgob.h"

#define Pf PGOBLIN_PATHPARM
#define Pt PGOBLIN_TEXTPARM
#define Pm PGOBLIN_MIFEDES
#define Pq PGOBLIN_PQRESULT
#define Po PGOBLIN_OUTSET
#define Ps PGOBLIN_STYLE
#define Pj PGOBLIN_JOB
#define Pc PGOBLIN_CONNECT

#define Fx PGOBLIN_ILLEGAL
#define Fi PGOBLIN_IGNORE
#define Fl PGOBLIN_NOLITER
#define Fe PGOBLIN_EXTENDED
#define Fu PGOBLIN_LEXLVUP
#define Fd PGOBLIN_LEXLDOWN
#define Io PGOBLIN_OUTSET
#define Id PGOBLIN_CTL
#define Ii PGOBLIN_ISIN
#define Ic PGOBLIN_CONNECT
#define Ij PGOBLIN_JOB
#define Is PGOBLIN_STYLE

const pgoblin_syntax pgoblin =
{ SYMREGS
, BINREGS
, PGOBLIN_max
, {PGOBLIN_ARG1S, PGOBLIN_ARG2S, PGOBLIN_ARG3S, PGOBLIN_ARG4S}
, {{PGOBLIN_OUTSET ,  0, 0, "out"  }
  ,{PGOBLIN_CTL    ,  1, 0, "ctl"  }
  ,{PGOBLIN_ISIN   ,  3, 0, "in"   }
  ,{PGOBLIN_CONNECT,  2, 0, "conn" }
  ,{PGOBLIN_JOB    ,  2, 0, "job"  }
  ,{PGOBLIN_STYLE  ,~12, 3, "style"}
  }
, {{ Fe                      , {    0,  0,     0,    0}, NULL           , ""}        /* 0 */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{                        0, {    0,  0,     0,    0}, NULL           , ""}
  ,{ Fi                      , {    0,  0,     0,    0}, NULL           , "!"}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx|         Ic          , {    0,  0, Po|Pc,    0}, NULL           , "connect"} /* 1 */
  ,{       Id|Ii|Ic          , {    0, Pt,    Pc,   Pt}, pgoblin_listen , "listen"}
  ,{    Io|Id|Ii|   Ij       , {Po|Pm, Pq, Po|Pj,   Pm}, pgoblin_exec   , "exec"}
  ,{ Fu                      , {    0,  0,     0,    0}, pgoblin_trap   , "trap"}
  ,{ Fx                      , {    0,  0,     0,    0}, pgoblin_call   , "call"}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , "include"}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{    Io|Id                , {Po|Pt, Pt,     0,    0}, pgoblin_echo   , "echo"}
  ,{    Io|Id                , {Po|Pf, Pt,     0,    0}, pgoblin_file   , "file"}
  ,{    Io|Id                , {Po|Pf, Pt,     0,    0}, pgoblin_cat    , "cat"}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{       Id|   Ic          , {    0, Pt,    Pc,    0}, pgoblin_perform, "perform"} /* 2 */
  ,{    Io|Id|   Ic          , {Po|Pq, Pt,    Pc,    0}, pgoblin_binpre , "binpresel"}
  ,{    Io|Id|   Ic          , {Po|Pq, Pt,    Pc,    0}, pgoblin_select , "select"}
  ,{    Io|Id|   Ic|Is|0x3000, {Po|Pm, Pt,    Pc,   Ps}, pgoblin_binsel , "binselect"}
  ,{    Io|Id|   Ic|Is|0x3000, {Po|Pm, Pt,    Pc,   Ps}, pgoblin_strsel , "strselect"}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{       Id|Ii|Ic          , {    0, Pt,    Pc,   Pm}, pgoblin_copyin , "copyin"}
  ,{    Io|Id|   Ic          , {Po|Pm, Pt,    Pc,    0}, pgoblin_copyout, "copyout"}
  ,{ Fl|Io|   Ii             , {Po|Pm, Pt,     0,   Pm}, pgoblin_getstr , "getstr"}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}      /* 3 */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}      /* 4 */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}      /* 5 */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}     /* 6 */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}      /* 7 */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}      /* 8 */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}      /* 9 */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}      /* A */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}      /* B */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}      /* C */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}      /* D */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}      /* E */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}      /* F */
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fl|         Ic          , {    0,  0,    Pc,    0}, pgoblin_begin  , "begin"}   /* 0 */
  ,{ Fl|         Ic          , {    0,  0,    Pc,    0}, pgoblin_end    , "end"}
  ,{ Fl|Io|   Ii|   Ij       , {Po|Pm,  0, Po|Pj,   Pm}, pgoblin_fork   , "fork"}
  ,{ Fl|            Ij       , {    0,  0,    Pj,    0}, pgoblin_wait   , "wait"}
  ,{ Fl|Fd                   , {    0,  0,     0,    0}, pgoblin_exit   , "exit"}
  ,{ Fl|Fd                   , {    0,  0,     0,    0}, pgoblin_return , "return"}
  ,{ Fl|Io|   Ii|   Is|0x2000, {Po|Pm,  0,    Ps,   Pq}, pgoblin_display, "display"}
  ,{ Fl|Io|   Ii             , {   Pm,  0,     0,Po|Pm}, pgoblin_pipe   , "pipe"}
  ,{ Fl|Io|   Ii             , {   Pm,  0,     0,Po|Pm}, pgoblin_close  , "close"}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}
  ,{ Fx                      , {    0,  0,     0,    0}, NULL           , NULL}

  ,{ Fl|Io                   , {Po|Pm,  0,     0,    0}, pgoblin_getarg , "getarg"}  /* 1 */
  ,{ Fl|Io                   , {Po|Pm,  0,     0,    0}, pgoblin_getenv , "getenv"}
  ,{ Fl|Io                   , {Po|Pm,  0,     0,    0}, pgoblin_getget , "getget"}
  ,{ Fl|Io|   Ii             , {Po|Pm,  0,     0,   Pm}, pgoblin_getpost, "getpost"}
  ,{ Fl|Io                   , {Po|Pm,  0,     0,    0}, pgoblin_getproc, "getproc"}
  ,{ Io|            Ij       , {Po|Pm,  0,    Pj,    0}, pgoblin_getjob , "getjob"}
  ,{ Fx                      , {    0,  0,     0,    0}, pgoblin_getspq , "getspq"}
} };
